<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

class Table {

	var $default_tabel_css = "tableborder";
	var $default_td_css = "tdborder";
	var $default_td_title_css = "tdtitleborder";
	var $default_tr_css = "trborder";
	var $default_td_align = "left";
	var $default_width = "100%";
	var $order_prefix = "";
	var $pr = "|";
	var $gl_count = 0;
	var $count_colspan = "1";
	var $tmp_tr_type = 0;
	var $head_title;
	var $body;
	var $config;
	var $aligns;
	var $valigns;
	var $widths;
	var $colspans;
	var $order_colon;

	function cfg($key, $value = ""){
		$this->config[$key] = $value;
	}

	function head($h_title = ""){
		$this->head_title = $h_title;
	}

	function colon_count(){
		return $this->count_colspan;
	}

	function delete_colon($colon){
/*
		for($i=0;$i<$this->gl_count;$i++){
			if($this->body[$i]['type'] == "line" || $this->body[$i]['type'] == "title"){
				$tmp = explode("|",$this->body[$i]['td']);
				unset($tmp[$colon]);
				$this->body[$i]['td'] = implode("|",$tmp);
			}
		}
//		$this->count_colspan --;
		$tmp = array();
*/
		$tmp = array_slice($this->order_colon, 0, $colon);
//		$this->order_colon = array_slice($this->order_colon, 0, 1);
		$tmp2 = array_merge($tmp, array_slice($this->order_colon, $colon+1));
//		$this->order_colon = $tmp2;
//		$this->order_colon = array_splice($this->order_colon, 4, -4);
//        unset($this->order_colon[5]);
		for($i=0;$i<$this->count_colspan;$i++){
//        	print $i."-".$this->order_colon[$i]."<br>";
		}
	}

	function tr($t_title = "", $bg_color = ""){
		$count = $this->gl_count;
		$this->body[$count]['type'] = "tr";
		$this->body[$count]['td'] = $t_title;
		$this->body[$count]['url'] = "";
		$this->body[$count]['bg_color'] = $bg_color;
		$this->gl_count ++;
	}

	function td($line = "", $conf = ""){
		$count = $this->gl_count;
		$this->body[$count]['type'] = "line";
		//print $conf."<br>";
		if ($conf<>"")
		{
			$tmp = explode("||", $conf);
			for($i=0;$i<count($tmp);$i++){
				$tmp1 = explode("|",$tmp[$i]);
				$this->body[$count][$tmp1[0]] = $tmp1[1];
			}
		}
		$this->body[$count]['td'] = $line;
		$this->count_colspan = count(explode($this->pr, $this->body[$count]['td']));
		$this->gl_count ++;
	}

	function title($titles_line = ""){
		$count = $this->gl_count;
		$this->body[$count]['type'] = "title";
		$this->body[$count]['td'] = $titles_line;
		$this->count_colspan = count(explode($this->pr, $this->body[$count]['td']));
		$this->body[$count]['url'] = "";
		$this->gl_count ++;
	}

	function align($colon, $align="left"){
		$this->aligns[$colon] = $align;
	}

	function valign($colon, $valign="center"){
		$this->valigns[$colon] = $valign;
	}

	function width($colon, $text = ""){
		$this->widths[$colon] = $text;
	}

	function colspan($colon, $val = "1"){
		$this->colspans[$colon] = $val;
	}

	function order($colon, $val){
		$this->order_colon[$colon] = $val;
	}

	function c1($num_colon = -1)
	{
		if (is_array($num_colon))
		{
			for($i=0;$i<count($num_colon);$i++)
			{
				$this->width($num_colon[$i],"1%");
				$this->align($num_colon[$i],"center");
			}
		}
		else
		{
			$num = ($num_colon == -1) ? $this->count_colspan : intval($num_colon);

			$this->width($num,"1%");
			$this->align($num,"center");
		}
	}

	function show($input_type = ""){
		$order = (isset($_GET[$this->order_prefix.'order'])) ? htmlspecialchars($_GET[$this->order_prefix.'order'],ENT_QUOTES) : isset($this->config['order']) ? $this->config['order'] : "";
		$order_by = (isset($_GET[$this->order_prefix.'order_by'])) ? htmlspecialchars($_GET[$this->order_prefix.'order_by'],ENT_QUOTES) : isset($this->config['order_by']) ? $this->config['order_by'] : "";

		$cellp = (isset($this->config['cellp'])) ? " CELLPADDING=\"".$this->config['cellp']."\" " : " CELLPADDING=\"3\"";
		$cells = (isset($this->config['cells'])) ? " CELLSPACING=\"".$this->config['cells']."\" " : " CELLSPACING=\"0\"";
		$height = (isset($this->config['height'])) ? " HIGHT=\"".$this->config['height']."\" " : "";
		$width = (isset($this->config['width'])) ? " WIDTH=\"".$this->config['width']."\" " : " WIDTH=\"".$this->default_width."\" ";
		$bgcolor = (isset($this->config['bgcolor'])) ? " BGCOLOR=\"".$this->config['bgcolor']."\" " : "";
		$align = (isset($this->config['align'])) ? " ALIGN=\"".$this->config['align']."\" " : "";
		$title_table = (isset($this->head_title)) ? "<TR><TD COLSPAN=\"".$this->count_colspan."\">".$this->head_title."</TD></TR>\n" : "";
		$index_colon = (isset($this->config['index_colon'])) ? $this->config['index_colon'] : "";
		$table_css = (isset($this->config['table_css'])) ? $this->config['table_css'] : $this->default_tabel_css;
		$td_css = (isset($this->config['td_css'])) ? $this->config['td_css'] : $this->default_td_css;
		$td_title_css = (isset($this->config['td_title_css'])) ? $this->config['td_title_css'] : $this->default_td_title_css;
		$tr_css = (isset($this->config['tr_css'])) ? $this->config['tr_css'] : $this->default_tr_css;

		$tmp = "<TABLE CLASS=\"".$table_css."\" ". $width . $height . $align . $cellp . $cells . $bgcolor ." >\n";
		$tmp .= $title_table;
		for ($i=0;$i<$this->gl_count;$i++){
			switch ($this->body[$i]['type']){
				case("tr"): {
					$td = "<TD CLASS=\"".$tr_css."\" COLSPAN=\"".$this->count_colspan."\">".$this->body[$i]['td']."</TD>";
					break;
				}
				case("line"):{
					$dat_arr = explode($this->pr, $this->body[$i]['td']);
					$tmp_line = "";
					for ($p=0;$p<count($dat_arr);$p++) {
						$align = (isset($this->aligns[$p+1])) ? "ALIGN=\"".$this->aligns[$p+1]."\"" : "ALIGN=\"".$this->default_td_align."\"";
						$valign = (isset($this->valigns[$p+1])) ? "VALIGN=\"".$this->valigns[$p+1]."\"" : "VALIGN=\"center\"";
						$onclick = (isset($this->body[$i]['onclick'])) ? "onclick=\"".$this->body[$i]['onclick']."\"" : "";
						$bgcolor = (isset($this->body[$i]['bgcolor'])) ? "bgcolor=\"".$this->body[$i]['bgcolor']."\"" : "";
						$ondblclick = (isset($this->body[$i]['ondblclick'])) ? "ondblclick=\"".$this->body[$i]['ondblclick']."\"" : "";
						$onmouseover = (isset($this->body[$i]['onmouseover'])) ? "onmouseover=\"".$this->body[$i]['onmouseover']."\"" : ""; //this.style.cursor='pointer'
						$width = ($index_colon && ($index_colon == $p+1)) ? " WIDTH=100% " : "";
						$width = (isset($this->widths[$p+1])) ? "WIDTH = '".$this->widths[$p+1]."'" : $width;
						$tmp_line .= "<TD ".$onclick." ".$ondblclick." ".$bgcolor." ".$onmouseover." ".$width." ".$align." CLASS=\"".$td_css."\" ".$valign.">".$dat_arr[$p]."</TD>\n";
					}
					$td = $tmp_line;
					break;
				}
				case("title"):{
					$dat_arr = explode($this->pr, $this->body[$i]['td']);
					$tmp_line = "";
					for ($p=0;$p<count($dat_arr);$p++) {
						$colspan = (isset($this->colspans[$p+1])) ? "COLSPAN=\"".$this->colspans[$p+1]."\"" : "";
						$valign = (isset($this->valigns[$p+1])) ? "VALIGN=\"".$this->valigns[$p+1]."\"" : "VALIGN=\"center\"";
						if (isset($this->order_colon[$p+1])&&$this->order_colon[$p+1]<>"") {
							$url = make_param_str_by_url($this->order_prefix."order|".$this->order_prefix."order_by");
							if ($this->order_colon[$p+1] == $order) {
								if ($order_by == "asc") {
									$im = "<img src='images/table/sort_down.gif'>";
									$url .= "&".$this->order_prefix."order=".$order."&".$this->order_prefix."order_by=desc";
								}
								else
								{
									$im = "<img src='images/table/sort_up.gif'>";
									$url .= "&".$this->order_prefix."order=".$order."&".$this->order_prefix."order_by=asc";
								}
								//$im = ($order_by == "asc") ? "<a href='".$url."&order=".$order."&order_by=desc'></a>" : "<a href='".$url."&order=".$order."&order_by=asc'><img src='images/table/sort_up.gif'></a>";
							} else {
								$im = "<img src='images/table/sort_no.gif'>";
								$url .= "&".$this->order_prefix."order=".$this->order_colon[$p+1]."&".$this->order_prefix."order_by=asc";
							}
							$tmp_line .= "<TD onclick=\"document.location.href='".$url."'\" onmouseout=\"this.className='tabletitle'\" onmouseover=\"this.style.cursor='pointer';this.className='titleselected'\" CLASS=\"tabletitle\"><table CELLPADDING=0 CELLSPACING=0 width=100%><tr><td align=left width=100%>".$dat_arr[$p]."</td><td>".$im."</td></tr></table></TD>";
						} else {
						//$align = (isset($this->aligns[$p+1])) ? "ALIGN=\"".$this->aligns[$p+1]."\"" : "ALIGN=\"".$this->default_td_align."\"";
							$tmp_line .= "<TD ".$colspan." ALIGN=left CLASS=\"tabletitle\" ".$valign.">".$dat_arr[$p]."</TD>";
						}
					}
					$td = $tmp_line;
					break;
				}
			}
			$tmp .= "<TR vAlign=\"center\" CLASS='trborder' id=\"row_".$i."\" onmouseover=\"this.className='trselected'\" onmouseout=\"this.className='trborder'\">".$td."</TR>\n";
		}
		$tmp .= "</TABLE>\n";
		if ($input_type <> "") {
			return $tmp;
		} else {
			print $tmp;
		}
		unset($this->body);
		unset($this->order_colon);
		unset($this->widths);
		unset($this->aligns);

		$this->order_prefix = "";
		$this->gl_count = 0;
	}
}

function make_param_str_by_url($dis = "")
{
	$tmp = explode("|",$dis);
	//print_r($dis_arr);
	for($i=0;$i<count($tmp);$i++) $dis_arr[$tmp[$i]]=1;
	$tmp =	explode("?",$_SERVER['REQUEST_URI']);
	$source = (isset($tmp[1])) ? $tmp[1] : "";
	$out = "";
	parse_str($source, $arr);
	$arr_key = array_keys($arr);
	for($i=0;$i<count($arr_key);$i++) $out .= (!array_key_exists($arr_key[$i], $dis_arr)) ? "&".$arr_key[$i]."=".$arr[$arr_key[$i]] : "";
	return "?".substr($out, 1);
}

?>