<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

# include kernel
require_once("./kernel.php");

# clear array varibles
$policy_list = array(); # policy list
$units_list = array(); # units list
$oid_index = array(); # db oids list

# tmp varibles
$units_name['user'] = "Пользователь";
$units_name['group'] = "Группа";
$units_name['host'] = "Хост";
$units_name['net'] = "Сеть";
$units_name['cluster'] = "Кластер";

$policy_list = $netams->policy();
if ($netams->errorno > 0)
	error_html("Ошибка при передаче данных NetAms сервера");

$units_list = $netams->units();
if ($netams->errorno > 0)
	error_html("Ошибка при передаче данных NetAms сервера");

# set varibles from GET query
$date = (isset($_GET['date'])) ? $_GET['date'] : date("d.m.Y");
$month =  (isset($_GET['month'])) ? $_GET['month'] : date("m");
$year =  (isset($_GET['year'])) ? $_GET['year'] : date("Y");
$ip =((isset($_GET['ip'])) && is_adv_user()) ? $_GET['ip'] : $_SERVER["REMOTE_ADDR"];

$oid = ((isset($_GET['oid'])) && is_adv_user()) ? $_GET['oid'] : unit_by_ip($ip);
$oid = (is_array($oid) && isset($oid['oid'])) ? $oid['oid'] : $oid;

# load policy and units from netams

if( (is_array($oid) && !isset($oid['oid'])) || $oid == "")
{
	if ( !is_adv_user())
		# if $ip user not define and user don`t have permision as advanced user then die
		die("Access denied");
	else
	{
		# else get first user
		$tmp = units_by("type","net");
		if(count($tmp) == 0) $tmp = units_by("type","host");
		if(count($tmp) == 0) $tmp = units_by("type","group");
		if(count($tmp) == 0) $tmp = units_by("type","user");
		if(count($tmp) == 0) $tmp = units_by("type","cluster");
		$tmp = current($tmp);
		$oid = $tmp['oid'];
	}
}

# convert oid from 16 to 10 code num
$db_oid = base_convert($oid,16,10);

# get db oid from protocols array by name set config
if (cfg("traffic_list") == "")
{
	error_html("Не указанны основные политики для отаброжения");
}

$traf_list = explode(" ",cfg("traffic_list"));
$traffic_list = array();
for($i=0;$i<count($traf_list);$i++)
{
	if (trim(@$policy_list[policy_id_by($traf_list[$i])]['db_oid']) <> '')
	{
		$traffic_list[] = $policy_list[policy_id_by($traf_list[$i])]['db_oid'];
	}
}

$proto_hide_list_tmp = explode(" ",trim(cfg("proto_hide_list")));
$proto_hide_list = array();
if (count($proto_hide_list_tmp) > 0 && $proto_hide_list_tmp[0] <> "")
{
	for($i=0;$i<count($proto_hide_list_tmp);$i++)
	{
		if (trim(@$policy_list[policy_id_by($proto_hide_list_tmp[$i])]['db_oid']) <> '')
		{
			$proto_hide_list[] = $policy_list[policy_id_by($proto_hide_list_tmp[$i])]['db_oid'];
		}
	}
}

if (count($traffic_list) <= 0)
	error_html("Ошибка списка основных политик");

if (cfg("quota_enabled"))
{
	if ($netams->quota_enabled() == false)
	{
		$cfg['quota_enabled'] = false;
	}
	else
	{
		$quota = $netams->get_quota($oid);
		if (!isset($quota[$oid])) $cfg['quota_enabled'] = false;
	}
}

//print_r($quota);
//die();


# if set date from GET query
if (isset($_GET['date']))
{
	$to_period = " за ".$date;
	$tmp = explode(".",$date);
	$sql_date = mktime(0,0,0,$tmp[1],$tmp[0],$tmp[2]);
	$prefix = "D";
}
# else period by default month
else
{
	$mon = array("Январь","Февраль","Март","Апрель","Май","Июнь","Июль","Август","Сентябрь","Октябрь","Ноябрь","Декабрь");
	$to_period = " на ".$mon[$month-1]." ".$year." года";
	$sql_date = mktime(0,0,0,$month, 1, $year);
	$prefix = "M";
}

#generate sql querys
$where_traffic_list = implode(" OR policy_oid = ", $traffic_list);
$sql_traffic = "SELECT `bytes_in` as `in`, `bytes_out` as `out`, `policy_oid` FROM `summary` WHERE t_from = ".$sql_date." AND unit_oid = ".$db_oid." AND ( policy_oid = ".$where_traffic_list." ) AND prefix = '".$prefix."'";
#set title page

$title = replace_space_separator($units_name[$units_list[unit_id_by("db_oid",$db_oid)]['type']].": ".$units_list[unit_id_by("db_oid",$db_oid)]['name'].(($units_list[unit_id_by("db_oid",$db_oid)]['type'] <> "group") ? " [".trim(str_replace("IP:","",$units_list[unit_id_by("db_oid",$db_oid)]['param']))."]" : "").$to_period);

# begin html echo
if ($xml)
{
	header("Content-type: text/xml");
	$user = $units_list[unit_id_by("oid",$oid)];
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<data><info><name>".$user['name']."</name><oid>".$oid."</oid><param>".$user['param']."</param></info><trafficlist>";
}
else
{
	head_html($title);
}
# get traffic from data base
$traffic = db_query($sql_traffic, "multi");

# create table class
$table = new Table();

$title_table = "Трафик|Входящий|Исходящий|Сумма";

if ($cfg['quota_enabled']) $title_table .= "|Квота";

$table->title($title_table);
for($i=0;$i<count($traffic);$i++)
{
	$name = $policy_list[policy_id_by($traffic[$i]['policy_oid'], "db_oid")]['name'];
	$policy_traf[$name] = array($traffic[$i]['in'], $traffic[$i]['out']);
	if (!$xml)
	{
		$img  = file_exists("images/proto/".$name.".gif") ? "<img src='images/proto/".$name.".gif'>&nbsp;" : "";
		$proto_tit = (isset($proto_title[$name])) ? $proto_title[$name] : $name;
		$str  = $img.$proto_tit."|".data_size($traffic[$i]['in'])."|".data_size($traffic[$i]['out'])."|".data_size($traffic[$i]['in']+$traffic[$i]['out']);
		if ($cfg['quota_enabled'])
		{
			$img = (trim(@$quota[$oid][$name]['status']) == "") ? "<img title='Квота не назначена' src='images/quota/notset.gif'>" : ((@$quota[$oid][$name]['status'] == "ACTIVE BLOCKED") ? "<img title='Протакол отключен' src='images/quota/disabled.gif'>" : "<img title='Протакол включен' src='images/quota/enabled.gif'>");
        	$str .= "|<a href='quota.php?oid=".$oid."'>".$img."</a>";
		}
		$table->td($str);
	}
	else
	{
		print "<traffic name=\"".$name."\"><in>".data_size($traffic[$i]['in'])."</in><out>".data_size($traffic[$i]['out'])."</out><sum>".data_size($traffic[$i]['in']+$traffic[$i]['out'])."</sum></traffic>";
	}
}

if ($xml) print "</trafficlist><protolist>";

if (cfg('traffic_sum_calc') <> "")
{
	$in  = 0;
	$out = 0;
	$n   = "=";

	$sum_calc = explode(" ",cfg('traffic_sum_calc'));
	for($i=0;$i<count($sum_calc);$i++)
	{
		if ($sum_calc[$i] == "+" || $sum_calc[$i] == "-")
		{
			$n = $sum_calc[$i];
		}
		elseif(isset($policy_traf[$sum_calc[$i]]))
		{
			switch($n)
			{
				case "-":
					$in = $in - $policy_traf[$sum_calc[$i]][0];
					$out = $out - $policy_traf[$sum_calc[$i]][1];
				break;
				case "+":
					$in = $in + $policy_traf[$sum_calc[$i]][0];
					$out = $out + $policy_traf[$sum_calc[$i]][1];
				break;
				default:
					$in = $policy_traf[$sum_calc[$i]][0];
					$out = $policy_traf[$sum_calc[$i]][1];
				break;
			}
		}
	}
	if (!$xml)
	{
		$str = "<b>Итог:</b>|<b>".data_size($in)."</b>|<b>".data_size($out)."</b>|<b>".data_size($in + $out)."</b>";
		if ($cfg['quota_enabled']) $str .= "|&nbsp;";
		$table->td($str);
	}
	else print "<trafsum><in>".data_size($in)."</in><out>".data_size($out)."</out><sum>".data_size($in + $out)."</sum>";
}

$date = (isset($_GET['date'])) ? "&date=".$_GET['date'] : "";
$month =  (isset($_GET['month'])) ? "&month=".$_GET['month'] : "";
$year =  (isset($_GET['year'])) ? "&year=".$_GET['year'] : "";
$urls_btn = (cfg("urls_monitor_enabled") == true) ? "<br>".btn("Просмотр посещаемости","urls.php?oid=".$oid.$date.$month.$year)."<br><br>" : "";

if (!$xml) {
	print "<img src='images/big_".$units_list[unit_id_by("db_oid",$db_oid)]['type'].".gif'>&nbsp;&nbsp;<font class=title>".$title."</font>".$urls_btn."<font color=gray>".@$units_list[unit_id_by("db_oid",$db_oid)]['comment']."</font>";
	if ($cfg['quota_enabled']) 	$table->c1();
	$table->show();
}

#order statistic
$stat_order = (isset($_GET['stat_order'])) ? htmlspecialchars($_GET['stat_order'],ENT_QUOTES) : "total";
$stat_order_by = (isset($_GET['stat_order_by'])) ? htmlspecialchars($_GET['stat_order_by'],ENT_QUOTES) : "desc";

$table->order_prefix = "stat_";
$table->cfg("order", $stat_order);
$table->cfg("order_by",$stat_order_by);

$table->order(1,"oid");
$table->order(2,"bytes_in");
$table->order(3,"bytes_out");
$table->order(4,"total");

# protocols traffic datatbase query
$where_proto_list = implode(" AND policy_oid <> ",$traffic_list) . ( (count($proto_hide_list) > 0 && $proto_hide_list[0] <> "") ? " AND policy_oid <> " . implode(" AND policy_oid <> ",$proto_hide_list) : "");
$sql_proto = "SELECT `policy_oid` as oid, `bytes_in` as `in`, `bytes_out` as `out`, (`bytes_in` + `bytes_out`) as total, `policy_oid` FROM `summary` WHERE t_from = ".$sql_date." AND unit_oid = ".$db_oid." AND policy_oid <> ".$where_proto_list." AND prefix = '".$prefix."' ORDER by `".$stat_order."` ".$stat_order_by;

$row = db_query($sql_proto, "multi");

$title_table = "Протокол|Входящий|Исходящий|Всего";
if ($cfg['quota_enabled']) $title_table .= "|Квота";

$table->title($title_table);

# calc protocols traffic
$sum = 0;
$sum_in = 0;
$sum_out = 0;
for($i=0;$i<count($row);$i++)
{
	$all = $row[$i]['in']+$row[$i]['out'];
	$sum = $sum + $all;
	$sum_in = $sum_in + $row[$i]['in'];
	$sum_out = $sum_out + $row[$i]['out'];
	$row[$i]['in'] = data_size($row[$i]['in']);
	$row[$i]['out'] = data_size($row[$i]['out']);
	$name = $policy_list[policy_id_by($row[$i]['oid'],"db_oid")]['name'];
	$img = (file_exists("images/proto/".$name.".gif")) ? "<img src='images/proto/".$name.".gif'>" : "";
	if ($all > 0)
		if (!$xml)
		{
			$proto_name = (isset($proto_title[$name])) ? $proto_title[$name] : $name;
			$str = $img."&nbsp;".$proto_name."|".$row[$i]['in']."|".$row[$i]['out']."|<b>".data_size($all)."</b>";
			if ($cfg['quota_enabled'])
			{
				$img = (trim(@$quota[$oid][$name]['status']) == "") ? "<img title='Квота не назначена' src='images/quota/notset.gif'>" : ((@$quota[$oid][$name]['status'] == "ACTIVE BLOCKED") ? "<img title='Протакол отключен' src='images/quota/disabled.gif'>" : "<img title='Протакол включен' src='images/quota/enabled.gif'>");
	        	$str .= "|<a href='quota.php?oid=".$oid."'>".$img."</a>";
			}
			$table->td($str);
		}
		else print "<proto name=\"".$policy_list[policy_id_by($row[$i]['oid'],"db_oid")]['name']."\"><in>".$row[$i]['in']."</in><out>".$row[$i]['out']."</out><sum>".data_size($all)."</sum></proto>";
}
if (!$xml)
{
	$str = "<b>Итого:</b> |<b>".data_size($sum_in)."</b>|<b>".data_size($sum_out)."</b>|<b>".data_size($sum)."</b>";
	if ($cfg['quota_enabled']) $str .= "|&nbsp;";
	$table->td($str);
}
# print protocols table
if ($sum>0 && !$xml)
{
	print "<BR><font class=title>Статистика по протоколам</font><BR>";
	if ($cfg['quota_enabled']) $table->c1();
	$table->show();
}
else
{
	print "</protolist></data>";
	die();
}

# if unit is group then echo users by this group
if ($units_list[unit_id_by("db_oid",$db_oid)]['type'] == "group" && cfg("group_show_policy") <> "")
{
	$title = "Юнит|IP";

	$order = (isset($_GET['order'])) ? htmlspecialchars($_GET['order'],ENT_QUOTES) : "total";
	$order_by = (isset($_GET['order_by'])) ? htmlspecialchars($_GET['order_by'],ENT_QUOTES) : "desc";

	$table->order(1,"oid");
	$table->order(3,"total");

	$table->cfg("order",$order);
	$table->cfg("order_by",$order_by);

	$group_pol = explode(" ", cfg("group_show_policy"));
	for($i=0;$i<count($group_pol);$i++)
	{
		if ($policy_list[policy_id_by($group_pol[$i])]['db_oid'] <> '') {
			$name = $group_pol[$i];
			$img = file_exists("images/proto/".$name.".gif") ? "<img src='images/proto/".$name.".gif'>" : "";
			$name = (isset($proto_title[$name])) ? $proto_title[$name] : $name;
			$title .= "|".$img."&nbsp;".$name;
			$group_policy[] = $policy_list[policy_id_by($group_pol[$i])]['db_oid'];
		}
	}

	$table->title($title);
	print "<br><font class=title>Статистика по группе</font>";
	$usr_list = units_parent("", $units_list[unit_id_by("db_oid",$db_oid)]['name']);
	//$usr_list = units_by("parent", $units_list[unit_id_by("db_oid",$db_oid)]['name']);

	$arr = array_keys($usr_list);
	$arr2 = array();
	for($i=0;$i<count($arr);$i++) $arr2[$i] = $usr_list[$arr[$i]]['db_oid'];
	$where_units = implode(" or unit_oid= ", $arr2);
	$where_policy = implode(" or policy_oid = ", $group_policy);
	$sql_traffic = "select `unit_oid` as `oid`, `bytes_in` + `bytes_out` as `total`, policy_oid from `summary` where t_from = ".$sql_date." and ( unit_oid = ".$where_units.") and ( policy_oid = ".$where_policy." ) and prefix = '".$prefix."' order by `".$order."` ".$order_by;

	# calc users traffic
	$traffic = db_query($sql_traffic, "multi");

	$date = (isset($_GET['date'])) ? "&date=".$_GET['date'] : "";
	$month =  (isset($_GET['month'])) ? "&month=".$_GET['month'] : "";
	$year =  (isset($_GET['year'])) ? "&year=".$_GET['year'] : "";
	$link = $date.$month.$year;

	$sum = array();

	for($i=0;$i<count($traffic);$i++)
	{
		$data[$traffic[$i]['oid']][$traffic[$i]['policy_oid']] = $traffic[$i]['total'];
	}
	if (count($data) > 0)
	{
		$arr = array_keys($data);
		for($i=0;$i<count($arr);$i++)
		{
			$td = "<img src='images/mini_".$units_list[unit_id_by("db_oid",$arr[$i])]['type'].".gif'>&nbsp;<a href='?oid=".$units_list[unit_id_by("db_oid",$arr[$i])]['oid'].$link."'>".replace_space_separator($units_list[unit_id_by("db_oid",$arr[$i])]['name'])."</a>|"
				 .(($units_list[unit_id_by("db_oid",$arr[$i])]['type'] <> "group") ? $units_list[unit_id_by("db_oid",$arr[$i])]['param'] : " ... &nbsp;");
			for($n=0;$n<count($group_policy);$n++)
			{
				$sum[$n] = @$sum[$n] + @$data[$arr[$i]][$group_policy[$n]];
				$td .= "|".data_size(@$data[$arr[$i]][$group_policy[$n]]);
			}
			$table->td($td);
		}
		$foot = "<b>Итого:</b>|&nbsp;";
		for($i=0;$i<count($group_policy);$i++) $foot .= "|<b>".data_size($sum[$i])."</b>";
		$table->td($foot);
		$table->show();
	}
}

# end html echo
foot_html();


?>